/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 83 "calculator.y" /* yacc.c:337  */

#include<stdio.h>
#include<string.h>
#include<stdlib.h> 
#include<math.h>
#include "calculator.h"
#include "xdata.h"

void addfunc4(char *name, double(*func)(double, double, double, double));
void addfunc3(char *name, double(*func)(double, double, double));
void addfunc2(char *name, double(*func)(double,double));
void addfunc(char *name, double(*func)(double));
double drand(double a); 
double series(double x, double a, double b);
void skip_to_end(void);
double dmax(double a, double b);
double dmin(double a, double b);
struct symtab* symlook(char *s);
double int2(double x);
int input(void);
int yyinput(void);
extern int yylex(void);
void yyerror(char *s);
void yyrestart ( FILE *input_file );
enum{ N_STRING, N_NUMBER, N_VARIABLE, N_FUNCTION };

extern Globals     g;
extern Spreadsheet s;
extern double answer;
extern char yy_hold_char, yy_n_chars;
extern char *text;
extern char *yytext;

extern char *yy_c_buf_p;
extern int yy_init;          /* whether we need to initialize */
extern int yy_start;         /* start state number */

int if_true=0;
int need_refresh=0;
int lineno, k, row, col;
static char tempstring[128];

#line 113 "y.tab.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NAME = 258,
    NUMBER = 259,
    Y = 260,
    X = 261,
    COL = 262,
    IF = 263,
    THEN = 264,
    ELSE = 265,
    EQ = 266,
    LE = 267,
    GE = 268,
    PLUS_EQUALS = 269,
    MINUS_EQUALS = 270,
    TIMES_EQUALS = 271,
    DIVIDE_EQUALS = 272,
    LOGICAL_AND = 273,
    LOGICAL_OR = 274,
    INCREMENT = 275,
    DECREMENT = 276,
    UMINUS = 277
  };
#endif
/* Tokens.  */
#define NAME 258
#define NUMBER 259
#define Y 260
#define X 261
#define COL 262
#define IF 263
#define THEN 264
#define ELSE 265
#define EQ 266
#define LE 267
#define GE 268
#define PLUS_EQUALS 269
#define MINUS_EQUALS 270
#define TIMES_EQUALS 271
#define DIVIDE_EQUALS 272
#define LOGICAL_AND 273
#define LOGICAL_OR 274
#define INCREMENT 275
#define DECREMENT 276
#define UMINUS 277

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 126 "calculator.y" /* yacc.c:352  */
  double dval;
          struct symtab *symp;
       

#line 205 "y.tab.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   762

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  75
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  156

#define YYUNDEFTOK  2
#define YYMAXUTOK   277

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      39,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    33,     2,     2,     2,    25,    22,     2,
      40,    41,    30,    29,    44,    28,     2,    31,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    45,    38,
      26,    37,    27,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    42,     2,    43,    24,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    35,    23,    36,    34,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    32
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   156,   156,   157,   158,   162,   162,   164,   163,   168,
     167,   172,   172,   173,   173,   174,   174,   176,   175,   181,
     181,   182,   182,   183,   183,   184,   185,   186,   194,   201,
     201,   202,   202,   203,   203,   204,   204,   206,   205,   211,
     211,   212,   212,   213,   213,   220,   221,   222,   223,   229,
     230,   231,   232,   233,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   253,   254,   255,   256,
     257,   258,   269,   279,   289,   299
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NAME", "NUMBER", "Y", "X", "COL", "IF",
  "THEN", "ELSE", "EQ", "LE", "GE", "PLUS_EQUALS", "MINUS_EQUALS",
  "TIMES_EQUALS", "DIVIDE_EQUALS", "LOGICAL_AND", "LOGICAL_OR",
  "INCREMENT", "DECREMENT", "'&'", "'|'", "'^'", "'%'", "'<'", "'>'",
  "'-'", "'+'", "'*'", "'/'", "UMINUS", "'!'", "'~'", "'{'", "'}'", "'='",
  "';'", "'\\n'", "'('", "')'", "'['", "']'", "','", "':'", "$accept",
  "statement_list", "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6",
  "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15",
  "$@16", "$@17", "$@18", "expression", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    38,   124,    94,    37,    60,    62,    45,    43,
      42,    47,   277,    33,   126,   123,   125,    61,    59,    10,
      40,    41,    91,    93,    44,    58
};
# endif

#define YYPACT_NINF -29

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-29)))

#define YYTABLE_NINF -50

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      99,   163,   -29,   -28,   -27,   -14,   -11,   -29,   279,   279,
     279,    99,   -29,   -29,   279,    86,   -29,   572,   279,   279,
     279,   279,   -25,    -9,   279,   311,   279,   279,   279,   279,
      12,   -29,   -29,   -29,   -29,   -29,   262,   488,   -29,   -29,
     279,   279,   279,   279,   279,   279,   279,   279,   279,   279,
     279,   279,   279,   279,   279,    -7,    14,   594,   616,   638,
     660,    16,    19,    26,    37,   682,    23,    44,   704,   142,
     704,   509,   271,   -29,    -3,    -3,    -3,   725,   725,   731,
     731,   731,   731,    -3,    -3,   -26,   -26,   -29,   -29,   -29,
     -29,    41,    42,    45,    43,    49,    56,    61,    62,   -29,
     -29,   -29,   -29,    70,    71,   279,   279,   -29,   279,   330,
      73,    38,   378,    74,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,   -29,   -29,   -29,   -29,   -29,   183,   -23,   354,   279,
     -29,   279,   -29,   -29,    75,   -29,   279,   224,   400,   279,
     530,   551,   -29,   422,   -29,   -29,    68,   109,    80,   279,
     444,    88,   279,   466,    94,   -29
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    70,    69,    68,    67,    66,     0,    28,     0,     0,
       0,     0,    26,    25,     0,     0,     2,    23,     0,     0,
       0,     0,    19,    21,     0,     0,     0,     0,     0,     0,
      70,    68,    66,    49,    50,    51,     0,     0,     1,     3,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,    13,    15,
      17,     0,     0,     0,     0,     5,    67,     0,     9,     0,
       7,     0,     0,    52,    59,    57,    58,    60,    61,    62,
      63,    64,    65,    55,    56,    46,    45,    47,    48,    24,
      44,     0,     0,     0,     0,     0,     0,     0,     0,    20,
      40,    22,    42,     0,     0,     0,     0,    71,     0,     0,
       0,     0,     0,     0,    27,     4,    12,    32,    14,    34,
      16,    36,    18,    38,     6,    30,     0,    46,     0,     0,
      10,     0,    54,     8,     0,    72,     0,     0,     0,     0,
       0,     0,    53,     0,    73,    75,    53,     0,     0,     0,
       0,     0,     0,     0,     0,    74
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -29,   105,   -12,   -29,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,    -8
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    15,    16,   103,   113,   110,    91,    93,    95,    97,
      61,    63,    55,   104,    92,    94,    96,    98,    62,    64,
      56,    17
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      33,    34,    35,    39,    53,    54,    37,   -49,   -49,    26,
      57,    58,    59,    60,   -39,    27,    65,    67,    68,    69,
      70,    71,   -49,    28,    39,    51,    52,    53,    54,    29,
     -41,    89,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    30,     2,    31,
       4,    32,    25,    90,    99,    40,    41,    42,   100,   109,
     115,   112,    43,    44,   101,   105,    45,    46,    47,    48,
      49,    50,   106,    52,    53,    54,   102,     9,    10,   116,
     131,   117,   119,   118,    14,   107,    38,   120,   108,     1,
       2,     3,     4,     5,     6,   121,     7,   126,   127,   122,
     128,   123,     1,     2,     3,     4,     5,     6,   124,     7,
     125,   130,   133,   147,     8,   148,    36,   139,   112,     9,
      10,   137,   149,   138,    12,    13,    14,     8,   140,   141,
     152,   143,     9,    10,    11,   155,     0,    12,    13,    14,
       0,   150,     0,     0,   153,    30,     2,    31,     4,    32,
       0,     0,     0,    40,    41,    42,     0,     0,     0,     0,
      43,    44,     0,     0,    45,    46,    47,    48,    49,    50,
     106,    52,    53,    54,     0,     9,    10,    18,    19,    20,
      21,     0,    14,    22,    23,   111,    30,     2,    31,     4,
      32,     0,     0,     0,    40,    41,    42,     0,     0,     0,
      24,    43,    44,    25,     0,    45,    46,    47,    48,    49,
      50,   106,    52,    53,    54,     0,     9,    10,     0,     0,
       0,     0,     0,    14,     0,     0,   134,    30,     2,    31,
       4,    32,     0,     0,     0,    40,    41,    42,     0,     0,
       0,     0,    43,    44,     0,     0,    45,    46,    47,    48,
      49,    50,   106,    52,    53,    54,     0,     9,    10,     0,
       0,     0,     0,     0,    14,     1,     2,     3,     4,     5,
       6,     0,     7,     0,     1,     2,     3,     4,     5,     6,
       0,     7,    30,     2,    31,     4,    32,     0,     0,     0,
       8,     0,     0,     0,     0,     9,    10,     0,    72,     8,
      12,    13,    14,     0,     9,    10,     0,     8,     0,    12,
      13,    14,     9,    10,    30,     2,    31,    66,    32,    14,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     8,
       0,    40,    41,    42,     9,    10,     0,     0,    43,    44,
       0,    14,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     0,     0,     0,    40,    41,    42,     0,     0,
       0,     0,    43,    44,     0,   129,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     0,     0,     0,    40,
      41,    42,     0,     0,     0,   135,    43,    44,   136,     0,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
       0,    40,    41,    42,     0,     0,     0,     0,    43,    44,
       0,   132,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     0,    40,    41,    42,     0,     0,     0,     0,
      43,    44,     0,   142,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     0,    40,    41,    42,     0,     0,
       0,     0,    43,    44,     0,   146,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     0,    40,    41,    42,
       0,     0,     0,     0,    43,    44,     0,   151,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     0,    40,
      41,    42,     0,     0,     0,     0,    43,    44,     0,   154,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      40,    41,    42,     0,     0,     0,     0,    43,    44,    73,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    40,    41,    42,     0,     0,     0,     0,    43,    44,
     114,     0,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    40,    41,    42,     0,     0,     0,     0,    43,
      44,   144,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    40,    41,    42,     0,     0,     0,     0,
      43,    44,   145,     0,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     0,    40,    41,    42,     0,     0,
       0,   -43,    43,    44,     0,     0,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     0,    40,    41,    42,
       0,     0,     0,   -31,    43,    44,     0,     0,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     0,    40,
      41,    42,     0,     0,     0,   -33,    43,    44,     0,     0,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
       0,    40,    41,    42,     0,     0,     0,   -35,    43,    44,
       0,     0,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     0,    40,    41,    42,     0,     0,     0,   -37,
      43,    44,     0,     0,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     0,    40,    41,    42,     0,     0,
       0,   -29,    43,    44,     0,     0,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    40,    41,    42,     0,
       0,     0,    40,    41,    42,     0,     0,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    49,    50,    51,
      52,    53,    54
};

static const yytype_int16 yycheck[] =
{
       8,     9,    10,    15,    30,    31,    14,    30,    31,    37,
      18,    19,    20,    21,    39,    42,    24,    25,    26,    27,
      28,    29,    45,    37,    36,    28,    29,    30,    31,    40,
      39,    38,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     3,     4,     5,
       6,     7,    40,    39,    38,    11,    12,    13,    39,    67,
      72,    69,    18,    19,    38,    42,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    39,    33,    34,    38,
      42,    39,    39,    38,    40,    41,     0,    38,    44,     3,
       4,     5,     6,     7,     8,    39,    10,   105,   106,    38,
     108,    39,     3,     4,     5,     6,     7,     8,    38,    10,
      39,    38,    38,    45,    28,     6,    11,    42,   126,    33,
      34,   129,    42,   131,    38,    39,    40,    28,   136,   137,
      42,   139,    33,    34,    35,    41,    -1,    38,    39,    40,
      -1,   149,    -1,    -1,   152,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    11,    12,    13,    -1,    -1,    -1,    -1,
      18,    19,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    33,    34,    14,    15,    16,
      17,    -1,    40,    20,    21,    43,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    12,    13,    -1,    -1,    -1,
      37,    18,    19,    40,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    33,    34,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    43,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    11,    12,    13,    -1,    -1,
      -1,    -1,    18,    19,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,     3,     4,     5,     6,     7,
       8,    -1,    10,    -1,     3,     4,     5,     6,     7,     8,
      -1,    10,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    28,
      38,    39,    40,    -1,    33,    34,    -1,    28,    -1,    38,
      39,    40,    33,    34,     3,     4,     5,     6,     7,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    11,    12,    13,    33,    34,    -1,    -1,    18,    19,
      -1,    40,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    11,    12,    13,    -1,    -1,
      -1,    -1,    18,    19,    -1,    45,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    11,
      12,    13,    -1,    -1,    -1,    41,    18,    19,    44,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    11,    12,    13,    -1,    -1,    -1,    -1,    18,    19,
      -1,    43,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    11,    12,    13,    -1,    -1,    -1,    -1,
      18,    19,    -1,    43,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    11,    12,    13,    -1,    -1,
      -1,    -1,    18,    19,    -1,    43,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    11,    12,    13,
      -1,    -1,    -1,    -1,    18,    19,    -1,    43,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    11,
      12,    13,    -1,    -1,    -1,    -1,    18,    19,    -1,    43,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      11,    12,    13,    -1,    -1,    -1,    -1,    18,    19,    41,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    11,    12,    13,    -1,    -1,    -1,    -1,    18,    19,
      41,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    11,    12,    13,    -1,    -1,    -1,    -1,    18,
      19,    41,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    11,    12,    13,    -1,    -1,    -1,    -1,
      18,    19,    41,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    11,    12,    13,    -1,    -1,
      -1,    39,    18,    19,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    11,    12,    13,
      -1,    -1,    -1,    39,    18,    19,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    11,
      12,    13,    -1,    -1,    -1,    39,    18,    19,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    11,    12,    13,    -1,    -1,    -1,    39,    18,    19,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    11,    12,    13,    -1,    -1,    -1,    39,
      18,    19,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    11,    12,    13,    -1,    -1,
      -1,    39,    18,    19,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    11,    12,    13,    -1,
      -1,    -1,    11,    12,    13,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    26,    27,    28,
      29,    30,    31
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,    10,    28,    33,
      34,    35,    38,    39,    40,    47,    48,    67,    14,    15,
      16,    17,    20,    21,    37,    40,    37,    42,    37,    40,
       3,     5,     7,    67,    67,    67,    47,    67,     0,    48,
      11,    12,    13,    18,    19,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    58,    66,    67,    67,    67,
      67,    56,    64,    57,    65,    67,     6,    67,    67,    67,
      67,    67,    36,    41,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    38,
      39,    52,    60,    53,    61,    54,    62,    55,    63,    38,
      39,    38,    39,    49,    59,    42,    28,    41,    44,    67,
      51,    43,    67,    50,    41,    48,    38,    39,    38,    39,
      38,    39,    38,    39,    38,    39,    67,    67,    67,    45,
      38,    42,    43,    38,    43,    41,    44,    67,    67,    42,
      67,    67,    43,    67,    41,    41,    43,    45,     6,    42,
      67,    43,    42,    67,    43,    41
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    46,    47,    47,    47,    49,    48,    50,    48,    51,
      48,    52,    48,    53,    48,    54,    48,    55,    48,    56,
      48,    57,    48,    58,    48,    48,    48,    48,    48,    59,
      48,    60,    48,    61,    48,    62,    48,    63,    48,    64,
      48,    65,    48,    66,    48,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     4,     0,     5,     0,     5,     0,
       5,     0,     5,     0,     5,     0,     5,     0,     5,     0,
       4,     0,     4,     0,     3,     1,     1,     4,     1,     0,
       5,     0,     5,     0,     5,     0,     5,     0,     5,     0,
       4,     0,     4,     0,     3,     3,     3,     3,     3,     2,
       2,     2,     3,     7,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     4,     6,     8,    18,     8
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 162 "calculator.y" /* yacc.c:1652  */
    {  (yyvsp[-2].symp)->value = (yyvsp[0].dval); }
#line 1520 "y.tab.c" /* yacc.c:1652  */
    break;

  case 7:
#line 164 "calculator.y" /* yacc.c:1652  */
    {  s.x[g.cc][g.rr] = (yyvsp[0].dval);
                   need_refresh = 1;
                }
#line 1528 "y.tab.c" /* yacc.c:1652  */
    break;

  case 9:
#line 168 "calculator.y" /* yacc.c:1652  */
    {  s.x[g.cc][g.rr] = (yyvsp[0].dval);
                   need_refresh = 1;
                }
#line 1536 "y.tab.c" /* yacc.c:1652  */
    break;

  case 11:
#line 172 "calculator.y" /* yacc.c:1652  */
    {  (yyvsp[-2].symp)->value += (yyvsp[0].dval); }
#line 1542 "y.tab.c" /* yacc.c:1652  */
    break;

  case 13:
#line 173 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value -= (yyvsp[0].dval); }
#line 1548 "y.tab.c" /* yacc.c:1652  */
    break;

  case 15:
#line 174 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value *= (yyvsp[0].dval); }
#line 1554 "y.tab.c" /* yacc.c:1652  */
    break;

  case 17:
#line 176 "calculator.y" /* yacc.c:1652  */
    { if ((yyvsp[0].dval) == 0.0)
                              yyerror((char*)"Division by zero");
                          else
                              (yyvsp[-2].symp)->value /= (yyvsp[0].dval);
                        }
#line 1564 "y.tab.c" /* yacc.c:1652  */
    break;

  case 19:
#line 181 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value++; }
#line 1570 "y.tab.c" /* yacc.c:1652  */
    break;

  case 21:
#line 182 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value--; }
#line 1576 "y.tab.c" /* yacc.c:1652  */
    break;

  case 23:
#line 183 "calculator.y" /* yacc.c:1652  */
    { /* printf("= %g\n", $1); */ answer=(yyvsp[0].dval); }
#line 1582 "y.tab.c" /* yacc.c:1652  */
    break;

  case 27:
#line 187 "calculator.y" /* yacc.c:1652  */
    {
                   if( (yyvsp[-1].dval) == 1)  if_true=1;
                               
                   else        {  if_true=0;
                                  skip_to_end();
                               }
                }
#line 1594 "y.tab.c" /* yacc.c:1652  */
    break;

  case 28:
#line 195 "calculator.y" /* yacc.c:1652  */
    {  
                   if(if_true) skip_to_end();
                }
#line 1602 "y.tab.c" /* yacc.c:1652  */
    break;

  case 29:
#line 201 "calculator.y" /* yacc.c:1652  */
    {  (yyvsp[-2].symp)->value = (yyvsp[0].dval); }
#line 1608 "y.tab.c" /* yacc.c:1652  */
    break;

  case 31:
#line 202 "calculator.y" /* yacc.c:1652  */
    {  (yyvsp[-2].symp)->value += (yyvsp[0].dval); }
#line 1614 "y.tab.c" /* yacc.c:1652  */
    break;

  case 33:
#line 203 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value -= (yyvsp[0].dval); }
#line 1620 "y.tab.c" /* yacc.c:1652  */
    break;

  case 35:
#line 204 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value *= (yyvsp[0].dval); }
#line 1626 "y.tab.c" /* yacc.c:1652  */
    break;

  case 37:
#line 206 "calculator.y" /* yacc.c:1652  */
    { if ((yyvsp[0].dval) == 0.0)
                              yyerror((char*)"Division by zero");
                          else
                              (yyvsp[-2].symp)->value /= (yyvsp[0].dval);
                        }
#line 1636 "y.tab.c" /* yacc.c:1652  */
    break;

  case 39:
#line 211 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value++; }
#line 1642 "y.tab.c" /* yacc.c:1652  */
    break;

  case 41:
#line 212 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value--; }
#line 1648 "y.tab.c" /* yacc.c:1652  */
    break;

  case 43:
#line 213 "calculator.y" /* yacc.c:1652  */
    { /* printf("= %g\n", $1);*/ answer=(yyvsp[0].dval); }
#line 1654 "y.tab.c" /* yacc.c:1652  */
    break;

  case 45:
#line 220 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) + (yyvsp[0].dval); }
#line 1660 "y.tab.c" /* yacc.c:1652  */
    break;

  case 46:
#line 221 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) - (yyvsp[0].dval); }
#line 1666 "y.tab.c" /* yacc.c:1652  */
    break;

  case 47:
#line 222 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) * (yyvsp[0].dval); }
#line 1672 "y.tab.c" /* yacc.c:1652  */
    break;

  case 48:
#line 224 "calculator.y" /* yacc.c:1652  */
    { if ((yyvsp[0].dval) == 0.0)
                              yyerror((char*)"Division by zero");
                          else
                              (yyval.dval) = (yyvsp[-2].dval) / (yyvsp[0].dval); 
                        }
#line 1682 "y.tab.c" /* yacc.c:1652  */
    break;

  case 49:
#line 229 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = -(yyvsp[0].dval); }
#line 1688 "y.tab.c" /* yacc.c:1652  */
    break;

  case 50:
#line 230 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = !(yyvsp[0].dval); }
#line 1694 "y.tab.c" /* yacc.c:1652  */
    break;

  case 51:
#line 231 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)(~(int)(yyvsp[0].dval)); }
#line 1700 "y.tab.c" /* yacc.c:1652  */
    break;

  case 52:
#line 232 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-1].dval); }
#line 1706 "y.tab.c" /* yacc.c:1652  */
    break;

  case 53:
#line 234 "calculator.y" /* yacc.c:1652  */
    {   if( ((int)(yyvsp[-4].dval) >= 0) &&  ((int)(yyvsp[-1].dval) >= 0) )
                   (yyval.dval) = s.x[(int)(yyvsp[-4].dval)][(int)(yyvsp[-1].dval)]; }
#line 1713 "y.tab.c" /* yacc.c:1652  */
    break;

  case 54:
#line 236 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = s.x[(int)(yyvsp[-2].dval)][(int)(yyvsp[-1].dval)]; }
#line 1719 "y.tab.c" /* yacc.c:1652  */
    break;

  case 55:
#line 237 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) < (yyvsp[0].dval); }
#line 1725 "y.tab.c" /* yacc.c:1652  */
    break;

  case 56:
#line 238 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) > (yyvsp[0].dval); }
#line 1731 "y.tab.c" /* yacc.c:1652  */
    break;

  case 57:
#line 239 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) <= (yyvsp[0].dval); }
#line 1737 "y.tab.c" /* yacc.c:1652  */
    break;

  case 58:
#line 240 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) >= (yyvsp[0].dval); }
#line 1743 "y.tab.c" /* yacc.c:1652  */
    break;

  case 59:
#line 241 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) == (yyvsp[0].dval); }
#line 1749 "y.tab.c" /* yacc.c:1652  */
    break;

  case 60:
#line 242 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) && (yyvsp[0].dval); }
#line 1755 "y.tab.c" /* yacc.c:1652  */
    break;

  case 61:
#line 243 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) || (yyvsp[0].dval); }
#line 1761 "y.tab.c" /* yacc.c:1652  */
    break;

  case 62:
#line 244 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)((int)(yyvsp[-2].dval) & (int)(yyvsp[0].dval)); }
#line 1767 "y.tab.c" /* yacc.c:1652  */
    break;

  case 63:
#line 245 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)((int)(yyvsp[-2].dval) | (int)(yyvsp[0].dval)); }
#line 1773 "y.tab.c" /* yacc.c:1652  */
    break;

  case 64:
#line 246 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)(pow((yyvsp[-2].dval),(yyvsp[0].dval))); }
#line 1779 "y.tab.c" /* yacc.c:1652  */
    break;

  case 65:
#line 248 "calculator.y" /* yacc.c:1652  */
    {  if((int)(yyvsp[0].dval))
                  (yyval.dval) = ((double)(((int)(yyvsp[-2].dval)) % ((int)(yyvsp[0].dval)))); 
               else
                  (yyval.dval) = 0;
            }
#line 1789 "y.tab.c" /* yacc.c:1652  */
    break;

  case 66:
#line 253 "calculator.y" /* yacc.c:1652  */
    {  (yyval.dval) = s.x[g.cc][g.rr]; }
#line 1795 "y.tab.c" /* yacc.c:1652  */
    break;

  case 67:
#line 254 "calculator.y" /* yacc.c:1652  */
    {  (yyval.dval) = g.rr+1; }
#line 1801 "y.tab.c" /* yacc.c:1652  */
    break;

  case 68:
#line 255 "calculator.y" /* yacc.c:1652  */
    {  (yyval.dval) = s.x[g.cc][g.rr]; }
#line 1807 "y.tab.c" /* yacc.c:1652  */
    break;

  case 70:
#line 257 "calculator.y" /* yacc.c:1652  */
    {  (yyval.dval) = (yyvsp[0].symp)->value;  }
#line 1813 "y.tab.c" /* yacc.c:1652  */
    break;

  case 71:
#line 259 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-3].symp)->funcptr)
                       (yyval.dval) = ((yyvsp[-3].symp)->funcptr)((yyvsp[-1].dval));
                    else
                    { 
                       sprintf(tempstring, "%s is not a 1-argument function\n", (yyvsp[-3].symp)->name);
                       yyerror(tempstring);
                       (yyval.dval) = 0.0;
                    }
                 }
#line 1828 "y.tab.c" /* yacc.c:1652  */
    break;

  case 72:
#line 270 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-5].symp)->funcptr2)
                       (yyval.dval) = ((yyvsp[-5].symp)->funcptr2)((yyvsp[-3].dval),(yyvsp[-1].dval));
                    else
                    {  sprintf(tempstring, "%s is not a 2-argument function\n", (yyvsp[-5].symp)->name);
                       yyerror(tempstring);
                       (yyval.dval) = 0.0;
                    }
                 }
#line 1842 "y.tab.c" /* yacc.c:1652  */
    break;

  case 73:
#line 280 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-7].symp)->funcptr3)
                       (yyval.dval) = ((yyvsp[-7].symp)->funcptr3)((yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
                    else
                    {  sprintf(tempstring, "%s is not a 3-argument function\n", (yyvsp[-7].symp)->name);
                       yyerror(tempstring);
                       (yyval.dval) = 0.0;
                    }
                 }
#line 1856 "y.tab.c" /* yacc.c:1652  */
    break;

  case 74:
#line 290 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-17].symp)->funcptr4)
                       (yyval.dval) = ((yyvsp[-17].symp)->funcptr4)((yyvsp[-13].dval),(yyvsp[-10].dval),(yyvsp[-5].dval),(yyvsp[-2].dval));
                    else
                    {  sprintf(tempstring, "%s is not a 4-argument function\n", (yyvsp[-17].symp)->name);
                       yyerror(tempstring);
                       (yyval.dval) = 0.0;
                    }
                 }
#line 1870 "y.tab.c" /* yacc.c:1652  */
    break;

  case 75:
#line 300 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-7].symp)->funcptr4)
                       (yyval.dval) = ((yyvsp[-7].symp)->funcptr4)((yyvsp[-5].dval),(yyvsp[-4].dval),(yyvsp[-2].dval),(yyvsp[-1].dval));
                    else
                    {  sprintf(tempstring, "%s is not a 4-argument function\n", (yyvsp[-7].symp)->name);
                       yyerror(tempstring);
                       (yyval.dval) = 0.0;
                    }
                 }
#line 1884 "y.tab.c" /* yacc.c:1652  */
    break;


#line 1888 "y.tab.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 310 "calculator.y" /* yacc.c:1918  */



void initialize_evaluator(void)
{   
  
   /* 1-parameter functions - new functions can be added here */
   addfunc((char*)"abs",  fabs); 
   addfunc((char*)"acos", acos); 
   addfunc((char*)"asin", asin); 
   addfunc((char*)"atan", atan); 
   addfunc((char*)"cos",  cos); 
   addfunc((char*)"cosh", cosh); 
   addfunc((char*)"exp",  exp);
   addfunc((char*)"int",  int2); 
   addfunc((char*)"log",  log); 
   addfunc((char*)"log10",log10); 
   addfunc((char*)"rand", randomnumber); 
   addfunc((char*)"sin",  sin); 
   addfunc((char*)"sinh", sinh); 
   addfunc((char*)"sqrt", sqrt);
   addfunc((char*)"tan",  tan); 
   addfunc((char*)"tanh", tanh); 
   addfunc((char*)"erf",  erf); 
   addfunc((char*)"fact", factorial); 
   addfunc((char*)"random", randomnumber); 

#ifdef HAVE_ACOSH
   addfunc((char*)"acosh",acosh); 
#endif
#ifdef HAVE_CBRT
   addfunc((char*)"cbrt", cbrt); 
#endif

   /* 2-parameter functions - new functions can be added here */
   addfunc2((char*)"pow", pow); 
   addfunc2((char*)"min", dmin); 
   addfunc2((char*)"max", dmax); 
   addfunc2((char*)"binom", binom); 
   addfunc2((char*)"binomial", binom); 

   /* 3-parameter functions - new functions can be added here */
   addfunc3((char*)"series", series); 

   /* 4-parameter functions - new functions can be added here */
   addfunc4((char*)"sum", sum); 
   addfunc4((char*)"sumsq", sumsq); 

   lineno=1;
   yy_n_chars = 0;
}


void yyerror(char *s)
{  
   formula_error(s); 
   yyrestart(NULL);
}

void add_variable(char *name, double value)
{
   struct symtab *sp = symlook(name);
   sp->funcptr = NULL;
   sp->funcptr2 = NULL;
   sp->value = value;
   sp->type = N_VARIABLE;
}

void addfunc(char *name, double(*func)(double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr = func;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->type = N_FUNCTION;
}

void addfunc2(char *name, double(*func)(double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr = NULL;
   sp->funcptr2 = func;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->type = N_FUNCTION;
}

void addfunc3(char *name, double(*func)(double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = func;
   sp->funcptr4 = NULL;
   sp->type = N_FUNCTION;
}

void addfunc4(char *name, double(*func)(double, double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = func;
   sp->type = N_FUNCTION;
}


double read_variable(char *name)
{
   struct symtab *sp = symlook(name);
   return sp->value;
}


struct symtab* symlook(char *s)
{
   struct symtab *sp;
   for(sp=symtab; sp< &symtab[NSYMS]; sp++)
   {  
       if(sp->name && !strcmp(sp->name, s)) return sp;  /* is it already here */
#ifdef LINUX
       if(!sp->name){ sp->name=strdup(s); return sp; }  /* is it free         */
#else
       if(!sp->name)
       {   
           sp->name = (char*)malloc(strlen(s)+1);
           strcpy(sp->name, s); 
           return sp; 
       }  
#endif
   }
   yyerror((char*)"Too many symbols, ask a wizard to enlarge me");
   return NULL;
}



void skip_to_end(void)
{
   while(strchr("\n ",yy_hold_char)!=NULL) yyinput(); 
   int got_left_brace = yy_hold_char=='{';
   if(got_left_brace)
   {   while(yy_hold_char != '}') yyinput();
   }else
   {   while(strchr(";}\n",yy_hold_char)==NULL) yyinput(); 
   }
   yyinput();
   while(yy_hold_char=='\n') yyinput(); 
}

double dmax(double a, double b){ if(a>b) return a; return b; }
double dmin(double a, double b){ if(a<b) return a; return b; }
double drand(double a){ a=a; return rand(); }
double series(double x, double a, double b)
{
   return gmp_series_term(x, (int)a, (int)b );
}
double int2(double x) { return (double)(int)(x); }
